impro.DragDropUpload = function() {
	return {
		onProgress : function(e, fileName) {
		},
		onComplete : function(e, fileName) {
		},
		onDropFile : function(e, fileName) {
		},
		url : "",
		mousein_class : "vdragover",

		init : function(id, options) {
			this._el = document.getElementById(id);
			this.el = jQuery(this._el);
			this.el.bind("dragover", jQuery.proxy(this._over, this)).bind(
					"dragenter", function() {
						return false;
					}).bind('dragleave', jQuery.proxy(this._leave, this)).bind(
					"drop", jQuery.proxy(this._drop, this))

			this.blockDocumentDrop();

			jQuery.extend(this, options);
		},
		blockDocumentDrop : function() {
			jQuery(document).bind('dragenter', function(e) {
				return false;
			}).bind('dragleave', function(e) {
				return false;
			}).bind('dragover', jQuery.proxy(function(e) {
				var dt = e.originalEvent.dataTransfer;
				if (!dt) {
					return;
				}
				dt.dropEffect = 'none';
				return false;
			}, this));
		},
		hideHighlight : function() {
			this.el.removeClass(this.mousein_class);
			return;
		},
		_leave : function(e) {
			return this.hideHighlight();
		},
		_over : function(e) {
			var dt = e.originalEvent.dataTransfer;
			if (!dt)
				return;
			// FF
			if (dt.types.contains && !dt.types.contains("Files"))
				return;
			// Chrome
			if (dt.types.indexOf && dt.types.indexOf("Files") == -1)
				return;

			if (jQuery.browser.webkit)
				dt.dropEffect = 'copy';

			this.el.addClass(this.mousein_class);

			return false;
		},
		_drop : function(e) {
			// debugger;
			// alert('test');

			// jQuery(e.originalTarget).parents('li')

			var dt = e.originalEvent.dataTransfer;
			if (!dt && !dt.files)
				return;

			this.hideHighlight();

			var files = dt.files;
			for ( var i = 0; i < files.length; i++) {
				var file = files[i];
				this.onDropFile(e, file.fileName);
				this.upload(file);
			}
			return false;
		},

		upload : function(file) {
			var xhr = new XMLHttpRequest();
			xhr.upload.addEventListener("progress", jQuery.proxy(function(e) {
				this.onProgress(e, file);
			}, this), false);
			xhr.onload = jQuery.proxy(function(e) {
				this.onComplete(e, file);
			}, this);
			xhr.open('POST', this.url + "?name=" + (file.fileName || file.name), true);
			xhr.send(file);
		}
	};
};